      subroutine SpherHarmDer2(h,f,n,klic)
      include 'fepc.cmn'
      include 'basic.cmn'
      dimension h(3),f(6,(n+1)*(n+1)),xyz(3)
      equivalence (xyz(1),x),(xyz(2),y),(xyz(3),z)
      r=sqrt(h(1)**2+h(2)**2+h(3)**2)
      if(r.lt..001) then
        call SetRealArrayTo(f,6*(n+1)*(n+1),0.)
        go to 9999
      endif
      if(n.ge.0) call SetRealArrayTo(f(1,1),6,0.)
      if(n.ge.1) then
        call CopyVek(h,xyz,3)
        r=sqrt(x**2+y**2+z**2)
        pom=1./r**5
        f(1,2)=( 2.*x**2*z-y**2*z-z**3)*pom
        f(2,2)=(-x**2*z+2.*y**2*z-z**3)*pom
        f(3,2)=(  -3.*x**2*z-3.*y**2*z)*pom
        f(4,2)=                3.*x*y*z*pom
        f(5,2)=       -x*(r**2-3.*z**2)*pom
        f(6,2)=       -y*(r**2-3.*z**2)*pom
        f(1,3)=(   -3.*x*y**2-3*x*z**2)*pom
        f(2,3)=(-x**3+2.*x*y**2-x*z**2)*pom
        f(3,3)=(-x**3-x*y**2+2.*x*z**2)*pom
        f(4,3)=       -y*(r**2-3.*x**2)*pom
        f(5,3)=       -z*(r**2-3.*x**2)*pom
        f(6,3)=                3.*x*y*z*pom
        f(1,4)=( 2.*x**2*y-y**3-y*z**2)*pom
        f(2,4)=(  -3.*x**2*y-3.*y*z**2)*pom
        f(3,4)=(-x**2*y-y**3+2.*y*z**2)*pom
        f(4,4)=       -x*(r**2-3.*y**2)*pom
        f(5,4)=                3.*x*y*z*pom
        f(6,4)=       -z*(r**2-3.*y**2)*pom
      endif
      if(n.ge.2) then
        pom=1./r**6
        f(1,5)=(-2./r**2+8.*x**2/r**4+
     1         (-2./r**4+8.*x**2/r**6)*(-x**2-y**2+2.*z**2))
        f(2,5)=(-2./r**2+8.*y**2/r**4+
     1         (-2./r**4+8.*y**2/r**6)*(-x**2-y**2+2.*z**2))
        f(3,5)=(4./r**2-16.*z**2/r**4+
     1         (-2./r**4+8.*z**2/r**6)*(-x**2-y**2+2.*z**2))
        f(4,5)= 24.*x*y*z**2*pom
        f(5,5)=-12.*x*z/r**4+24.*x*z**3*pom
        f(6,5)=-12.*y*z/r**4+24.*y*z**3*pom
        f(1,6)=x*z*(-6./r**4+8.*x**2*pom)
        f(2,6)=x*z*(-2./r**4+8.*y**2*pom)
        f(3,6)=x*z*(-6./r**4+8.*z**2*pom)
        f(4,6)=(y*z*(-2.+(8.*x**2)/r**2))/r**4
        f(5,6)=(r**4-2.*r**2*x**2-2.*r**2*z**2+8.*x**2*z**2)*pom
        f(6,6)=(x*y*(-2.+(8.*z**2)/r**2))/r**4
        f(1,7)=y*z*(-2./r**4+8.*x**2*pom)
        f(2,7)=y*z*(-6./r**4+8.*y**2*pom)
        f(3,7)=y*z*(-6./r**4+8.*z**2*pom)
        f(4,7)=x*z*(-2.+(8.*y**2)/r**2)/r**4
        f(5,7)=x*y*(-2.+(8.*z**2)/r**2)/r**4
        f(6,7)=(x**4-y**4+6.*y**2*z**2-z**4)*pom
        f(1,8)=1./r**2-4.*x**2/r**4+(-1./r**4+4.*x**2*pom)*(x**2-y**2)
        f(2,8)=-1./r**2+4.*y**2/r**4+(-1./r**4+4.*y**2*pom)*(x**2-y**2)
        f(3,8)=-(r**2-4.*z**2)*(x**2-y**2)*pom
        f(4,8)=4.*x*y*(x**2-y**2)*pom
        f(5,8)=2.*x*z*(-r**2+2.*x**2-2.*y**2)*pom
        f(6,8)=2.*y*z*( r**2+2.*x**2-2.*y**2)*pom
        f(1,9)=x*y*(-6./r**4+8.*x**2*pom)
        f(2,9)=x*y*(-6./r**4+8.*y**2*pom)
        f(3,9)=x*y*(-2./r**4+8.*z**2*pom)
        f(4,9)=(r**4-2.*r**2*x**2-2.*r**2*y**2+8.*x**2*y**2)*pom
        f(5,9)=y*(-2.*z/r**4+8.*x**2*z*pom)
        f(6,9)=x*(-2.*z/r**4+8.*y**2*z*pom)
      endif
      if(n.ge.3) then
        pom=1./r**7
        f(1,10)=3.*z*(r**4-3.*r**2*x**2-5.*r**2*z**2+25.*x**2*z**2)*pom
        f(2,10)=3.*z*(r**4-3.*r**2*y**2-5.*r**2*z**2+25.*y**2*z**2)*pom
        f(3,10)=(39.*z*r**4-114.*z**3*r**2+75.*z**5)*pom
        f(4,10)=(-3.*x*y*z*(-2.*r**2+5.*x**2+5.*y**2-20.*z**2))*pom
        f(5,10)=(3.*x*(r**2*x**2+r**2*y**2-12.*r**2*z**2-5.*x**2*z**2
     1           -5.*y**2*z**2+20.*z**4))*pom
        f(6,10)=(3.*y*(r**2*x**2+r**2*y**2-12.*r**2*z**2-5.*x**2*z**2
     1          -5.*y**2*z**2+20.*z**4))*pom
        f(1,11)= x*(-6.*r**4+21.*r**2*x**2-15.*x**4+9.*r**2*y**2
     1          -15.*x**2*y**2-36.*r**2*z**2+60.*x**2*z**2)*pom
        f(2,11)= x*(-2.*r**4+3.*r**2*x**2+15.*r**2*y**2-15.*x**2*y**2
     1              -15.*y**4-12.*r**2*z**2+60.*y**2*z**2)*pom
        f(3,11)= x*(8.*r**4+3.*r**2*x**2+3.*r**2*y**2-60.*r**2*z**2
     1              -15.*x**2*z**2-15.*y**2*z**2+60.*z**4)*pom
        f(4,11)= y*(r**4-3.*r**2*x**2-15.*r**2*z**2+75.*x**2*z**2)*pom
        f(5,11)= z*(11.-33.*x**2/r**2-15.*z**2/r**2+
     1              75.*x**2*z**2/r**4)/r**3
        f(6,11)= -x*y*z*(28.*r**2+5.*x**2+5.*y**2-70.*z**2)*pom
        f(1,12)= y*(-2.*r**4+15.*r**2*x**2+3.*r**2*y**2-15.*x**4
     1              -15.*x**2*y**2-12.*r**2*z**2+60.*x**2*z**2)*pom
        f(2,12)= y*(-6.*r**4+9.*r**2*x**2+21.*r**2*y**2-15.*x**2*y**2
     1              -15.*y**4-36.*r**2*z**2+60.*y**2*z**2)*pom
        f(3,12)= y*(8.*r**4+3.*r**2*x**2+3.*r**2*y**2-60.*r**2*z**2
     1              -15.*x**2*z**2-15.*y**2*z**2+60.*z**4)*pom
        f(4,12)= 2.*x*y**2/r**5+(r**2-15.*z**2)*(x/r**5-5.*x*y**2*pom)
        f(5,12)= -28.*x*y*z/r**5-(5.*x*y*z*(r**2-15.*z**2))*pom
        f(6,12)= z*(11.-33.*y**2/r**2-15.*z**2/r**2+
     1              75.*y**2*z**2/r**4)/r**3
        f(1,13)= z*( 2.*r**4+3.*r**2*y**2-15.*r**2*x**2-15.*x**2*y**2
     1              +15.*x**4)*pom
        f(2,13)= z*(-2.*r**4-3.*r**2*x**2+15.*r**2*y**2+15.*x**2*y**2
     1              -15.*y**4)*pom
        f(3,13)= 3.*z*(-3.*r**2+5.*z**2)*(x-y)*(x+y)*pom
        f(4,13)= 15.*x*y*z*(x-y)*(x+y)*pom
        f(5,13)= x*(2.*r**4-3.*r**2*x**2+3.*r**2*y**2-6.*r**2*z**2
     1              +15.*x**2*z**2-15.*y**2*z**2)*pom
        f(6,13)= y*(-2.*r**4-3.*r**2*x**2+3.*r**2*y**2+6.*r**2*z**2
     1              +15.*x**2*z**2-15.*y**2*z**2)*pom
        f(1,14)= x*y*z*(-18.*r**2+30.*x**2)*pom
        f(2,14)= x*y*z*(-18.*r**2+30.*y**2)*pom
        f(3,14)= x*y*z*(-18.*r**2+30.*z**2)*pom
        f(4,14)= 2.*z*(r**4-3.*r**2*x**2-3.*r**2*y**2+15.*x**2*y**2)*pom
        f(5,14)= 2.*y*(r**4-3.*r**2*x**2-3.*r**2*z**2+15.*x**2*z**2)*pom
        f(6,14)= 2.*x*(r**4-3.*r**2*y**2-3.*r**2*z**2+15.*y**2*z**2)*pom
        f(1,15)= x*(6.*r**4-21.*r**2*x**2+15.*x**4+27.*r**2*y**2
     1              -45.*x**2*y**2)*pom
        f(2,15)=-3.*x*(2.*r**4+r**2*x**2-15.*r**2*y**2-5.*x**2*y**2
     1                 +15.*y**4)*pom
        f(3,15)= -3.*x*(r**2-5.*z**2)*(x**2-3.*y**2)*pom
        f(4,15)= y*(-6.*r**4+9.*r**2*x**2+15.*x**4+9.*r**2*y**2
     1              -45.*x**2*y**2)*pom
        f(5,15)= z*(-9.*x**2+15.*x**4/r**2+9.*y**2-
     1                                       (45.*x**2*y**2)/r**2)/r**5
        f(6,15)= 3.*x*y*z*(6.*r**2+5.*x**2-15.*y**2)*pom
        f(1,16)= 3.*y*(2.*r**4-15.*r**2*x**2+15.*x**4+
     1                                      r**2*y**2-5.*x**2*y**2)*pom
        f(2,16)= y*(-6.*r**4-27.*r**2*x**2+21.*r**2*y**2+45.*x**2*y**2
     1              -15.*y**4)*pom
        f(3,16)= 3.*y*(r**2-5.*z**2)*(y**2-3.*x**2)*pom
        f(4,16)= x*(6.*r**4-9.*r**2*x**2-9.*r**2*y**2+
     1                                      45.*x**2*y**2-15.*y**4)*pom
        f(5,16)= 3.*x*y*z*(-6.*r**2+15.*x**2-5.*y**2)*pom
        f(6,16)= z*(-9.*x**2+9.*y**2+45.*x**2*y**2/r**2
     1              -15.*y**4/r**2)/r**5
      endif
      if(n.ge.4) then
        pom=1./r**8
        f(1,17)=z**2*(60.-240.*x**2/r**2-140.*z**2/r**2
     1              +840.*x**2*z**2/r**4)/r**4
        f(2,17)=z**2*(60.-240.*y**2/r**2-140.*z**2/r**2
     1              +840.*y**2*z**2/r**4)/r**4
        f(3,17)=-60.*(r-z)*(r+z)*(r**4-11.*r**2*z**2+14.*z**4)*pom
        f(4,17)=x*y*z**2*(-240.+(840.*z**2)/r**2)/r**6
        f(5,17)=(40.*x*z*(3.*r**4-20.*r**2*z**2+21.*z**4))*pom
        f(6,17)=(40.*y*z*(3.*r**4-20.*r**2*z**2+21.*z**4))*pom
        f(1,18)=6.*x*z*(3.*r**4-4.*r**2*x**2-14.*r**2*z**2
     1                  +28.*x**2*z**2)*pom
        f(2,18)=x*z*(6.-24.*y**2/r**2-28.*z**2/r**2
     1               +168.*y**2*z**2/r**4)/r**4
        f(3,18)=4.*x*z*(15.*r**4-55.*r**2*z**2+42.*z**4)*pom
        f(4,18)=y*z*(6.-24.*x**2/r**2-28.*z**2/r**2+
     1             168.*x**2*z**2/r**4)/r**4
        f(5,18)=(-3.+6.*x**2/r**2+27.*z**2/r**2-108.*x**2*z**2/r**4
     1         -28.*z**4/r**4+168.*x**2*z**4/r**6)/r**2
        f(6,18)=6.*x*y*(r**4-18.*r**2*z**2+28.*z**4)*pom
        f(1,19)=y*z*(6.-24.*x**2/r**2-28.*z**2/r**2
     1               +168.*x**2*z**2/r**4)/r**4
        f(2,19)=6.*y*z*(3.*r**4-4.*r**2*y**2-14.*r**2*z**2
     1                  +28.*y**2*z**2)*pom
        f(3,19)=4.*y*z*(15.*r**4-55.*r**2*z**2+42.*z**4)*pom
        f(4,19)=x*z*(6.-24.*y**2/r**2-28.*z**2/r**2
     1               +168.*y**2*z**2/r**4)/r**4
        f(5,19)=6*x*y*(r**4-18.*r**2*z**2+28.*z**4)*pom
        f(6,19)=(-3.+6.*y**2/r**2+27.*z**2/r**2-
     1            108.*y**2*z**2/r**4-28.*z**4/r**4
     2           +168.*y**2*z**4/r**6)/r**2
        f(1,20)=-4*(3.*r**4*x**2-9.*r**2*x**4+6.*x**6+r**2*y**4
     1              -6.*x**2*y**4-3.*r**4*z**2+30.*r**2*x**2*z**2
     2              -36.*x**4*z**2-6.*r**2*y**2*z**2
     3              +36.*x**2*y**2*z**2)*pom
        f(2,20)=4*(r**2*x**4+3.*r**4*y**2-6.*x**4*y**2-9.*r**2*y**4
     1             +6.*y**6-3.*r**4*z**2-6.*r**2*x**2*z**2
     2             +30.*r**2*y**2*z**2+36.*x**2*y**2*z**2
     3             -36.*y**4*z**2)*pom
        f(3,20)=4.*(x-y)*(x+y)*(3.*r**4+r**2*x**2+r**2*y**2
     1                          -30.*r**2*z**2-6.*x**2*z**2
     2                          -6.*y**2*z**2+36.*z**4)*pom
        f(4,20)=-8.*x*y*(x-y)*(x+y)*(-2.*r**2+3*x**2+3.*y**2
     1                               -18.*z**2)*pom
        f(5,20)=x*z*( 24.*r**4-32.*r**2*x**2-24.*x**4+48.*r**2*y**2
     1               +24.*y**4-48.*r**2*z**2+144.*x**2*z**2
     2               -144.*y**2*z**2)*pom
        f(6,20)=y*z*(-24.*r**4-48.*r**2*x**2-24.*x**4+32.*r**2*y**2
     1               +24.*y**4+48.*r**2*z**2+144.*x**2*z**2
     2               -144.*y**2*z**2)*pom
        f(1,21)=x*y*(-12.*r**4+56.*r**2*x**2-48.*x**4+24.*r**2*y**2
     1               -48.*x**2*y**2-144.*r**2*z**2+288.*x**2*z**2)*pom
        f(2,21)=x*y*(-12.*r**4+24.*r**2*x**2+56.*r**2*y**2-48.*x**2*y**2
     1               -48.*y**4-144.*r**2*z**2+288.*y**2*z**2)*pom
        f(3,21)=8.*x*y*(3.*r**4+r**2*x**2+r**2*y**2-30.*r**2*z**2
     1                 -6.*x**2*z**2-6.*y**2*z**2+36.*z**4)*pom
        f(4,21)= (-2.*(r**6-2.*r**4*x**2-2.*r**4*y**2+
     1                 8.*r**2*x**2*y**2-7.*r**4*z**2
     2                 +28.*r**2*x**2*z**2+28.*r**2*y**2*z**2
     3                 -168.*x**2*y**2*z**2))*pom
        f(5,21)=y*z*(32.-128.*x**2/r**2-56.*z**2/r**2
     1               +336.*x**2*z**2/r**4)/r**4
        f(6,21)=x*z*(32.-128.*y**2/r**2-56.*z**2/r**2
     1               +336.*y**2*z**2/r**4)/r**4
        f(1,22)=x*z*( 6.*r**4-28.*r**2*x**2+24.*x**4+36.*r**2*y**2
     1               -72.*x**2*y**2)*pom
        f(2,22)=x*z*(-6.*r**4-4.*r**2*x**2+60.*r**2*y**2+24.*x**2*y**2
     1               -72.*y**4)*pom
        f(3,22)=12.*x*z*(-r**2+2.*z**2)*(x**2-3.*y**2)*pom
        f(4,22)=-6.*y*z*(r**4-2.*r**2*x**2-4.*x**4-2.*r**2*y**2
     1                    +12.*x**2*y**2)*pom
        f(5,22)=((3.*x**2-3.*y**2)/r**4-4.*z**2*(3.*x**2-3.*y**2)/r**6
     1           -4.*x*(x**3-3.*x*y**2)/r**6
     2           +24.*x*z**2*(x**3-3.*x*y**2)*pom)
        f(6,22)=x*y*(-6.*r**4-4.*r**2*x**2+12.*r**2*y**2+24.*r**2*z**2
     1               +24.*x**2*z**2-72.*y**2*z**2)*pom
        f(1,23)=y*z*(6.*r**4-60.*r**2*x**2+72.*x**4+4.*r**2*y**2
     1               -24.*x**2*y**2)*pom
        f(2,23)=y*z*(-6.*r**4-36.*r**2*x**2+28.*r**2*y**2+72.*x**2*y**2
     1               -24.*y**4)*pom
        f(3,23)=-12.*y*z*(-r**2+2.*z**2)*(-3.*x**2+y**2)*pom
        f(4,23)= 6.*x*z*(r**4-2.*r**2*x**2-2*r**2*y**2+12.*x**2*y**2
     1                   -4.*y**4)*pom
        f(5,23)=x*y*(6.*r**4-12.*r**2*x**2+4.*r**2*y**2-24.*r**2*z**2
     1               +72.*x**2*z**2-24.*y**2*z**2)*pom
        f(6,23)=(3.*x**2-3.*y**2-12.*x**2*y**2/r**2+4.*y**4/r**2
     1           -12.*x**2*z**2/r**2+12.*y**2*z**2/r**2
     1           +72.*x**2*y**2*z**2/r**4-24.*y**4*z**2/r**4)/r**4
        f(1,24)=(12.*r**4*x**2-36.*r**2*x**4+24.*x**6-12.*r**4*y**2
     1           +120.*r**2*x**2*y**2-144.*x**4*y**2-4.*r**2*y**4
     2           +24.*x**2*y**4)*pom
        f(2,24)=(-12.*r**4*x**2-4.*r**2*x**4+12.*r**4*y**2
     1           +120.*r**2*x**2*y**2+24.*x**4*y**2-36.*r**2*y**4
     2           -144.*x**2*y**4+24.*y**6)*pom
        f(3,24)=-4.*(r**2-6.*z**2)*(x**4-6.*x**2*y**2+y**4)*pom
        f(4,24)=8.*x*y*(-3.*r**4+4.*r**2*x**2+3.*x**4
     1                  +4.*r**2*y**2-18.*x**2*y**2+3*y**4)*pom
        f(5,24)=x*z*(-16.*r**2*x**2+24.*x**4+48.*r**2*y**2
     1               -144.*x**2*y**2+24.*y**4)*pom
        f(6,24)=y*z*(48.*r**2*x**2+24.*x**4-16.*r**2*y**2
     1               -144.*x**2*y**2+24.*y**4)*pom
        f(1,25)=8.*x*y*(3.*r**4-14.*r**2*x**2+12.*x**4+6.*r**2*y**2
     1                  -12.*x**2*y**2)*pom
        f(2,25)=-8.*x*y*(3.*r**4-14.*r**2*y**2+12.*y**4+6.*r**2*x**2
     1                   -12.*x**2*y**2)*pom
        f(3,25)=-16.*x*y*(r**2-6.*z**2)*(x-y)*(x+y)*pom
        f(4,25)= 4.*(x-y)*(x+y)*(3.*r**4-4.*r**2*x**2-4.*r**2*y**2
     1          +24.*x**2*y**2)*pom
        f(5,25)= 16.*y*z*(-3.*r**2*x**2+6.*x**4+r**2*y**2
     1                    -6.*x**2*y**2)*pom
        f(6,25)=-16.*x*z*(r**2*x**2-3.*r**2*y**2-6.*x**2*y**2
     1                    +6.*y**4)*pom
      endif
      if(n.ge.5) then

      endif
      if(n.ge.6) then

      endif
      if(n.ge.7) then

      endif
      if(Klic.eq.1) then
        do i=1,(n+1)**2
          do j=1,6
            f(j,i)=f(j,i)*Clm(i)
          enddo
        enddo
      else if(Klic.eq.2) then
        do i=1,(n+1)**2
          do j=1,6
            f(j,i)=f(j,i)*Mlm(i)
          enddo
        enddo
      else if(Klic.eq.3) then
        do i=1,(n+1)**2
          do j=1,6
            f(j,i)=f(j,i)*Llm(i)
          enddo
        enddo
      endif
9999  return
      end
